#include "libscl.h"

using namespace scl;
using namespace std;

int main(int argc, char** argp, char** envp)
{
  
  cout << boolalpha << '\n';

  REAL x = 1.0;

  cout << x << '\t'  << IsFinite(x)  << "\tIsFinite(x)" << '\n';
  cout << -x << '\t' << IsFinite(-x) << "\tIsFinite(x)" << '\n';

  x = 1.0;
  x = x/0.0;

  cout << '\n';
  cout << x << '\t' << IsFinite(x)     << "\tIsFinite(x)" << '\n';
  cout << x << '\t' << (x == x)        << "\t(x == x)"   << '\n';
  cout << x << '\t' << (x < REAL_MAX)  << "\t(x < REAL_MAX)"  << '\n';
  cout << x << '\t' << (x > -REAL_MAX) << "\t(x > -REAL_MAX)" << '\n';

  x = -1.0;
  x = x/0.0;

  cout << '\n';
  cout << x << '\t' << IsFinite(x)     << "\tIsFinite(x)" << '\n';
  cout << x << '\t' << (x == x)        << "\t(x == x)"   << '\n';
  cout << x << '\t' << (x < REAL_MAX)  << "\t(x < REAL_MAX)"  << '\n';
  cout << x << '\t' << (x > -REAL_MAX) << "\t(x > -REAL_MAX)" << '\n';

  x = 0.0;
  x = x/0.0;

  cout << '\n';
  cout << x << '\t' << IsFinite(x)     << "\tIsFinite(x)" << '\n';
  cout << x << '\t' << (x == x)        << "\t(x == x)"   << '\n';
  cout << x << '\t' << (x < REAL_MAX)  << "\t(x < REAL_MAX)"  << '\n';
  cout << x << '\t' << (x > -REAL_MAX) << "\t(x > -REAL_MAX)" << '\n';

  x = -0.0;
  x = x/0.0;

  cout << '\n';
  cout << x << '\t' << IsFinite(x)     << "\tIsFinite(x)" << '\n';
  cout << x << '\t' << (x == x)        << "\t(x == x)"   << '\n';
  cout << x << '\t' << (x < REAL_MAX)  << "\t(x < REAL_MAX)"  << '\n';
  cout << x << '\t' << (x > -REAL_MAX) << "\t(x > -REAL_MAX)" << '\n';

  x = REAL_MAX;
  
  cout << '\n';
  cout << x << '\t' << IsFinite(x) << "\tIsFinite(x)" << '\n';

  x = -REAL_MAX;
  
  cout << '\n';
  cout << x << '\t' << IsFinite(x) << "\tIsFinite(x)" << '\n';

  return 0;
}
