#include "sclfuncs.h"
using namespace scl;
using namespace std;

int main(int argc, char** argp, char** envp)
{
  const INTEGER YYYY0 = 1850;
  const INTEGER MM0 = 1;
  const INTEGER DD0 = 1;
  const REAL JD0 = 2396758.5;

  INTEGER YYYY = YYYY0;
  INTEGER MM = MM0;
  INTEGER DD = DD0;
  REAL JD = JD0;

  cout << '\n';
  cout << "INTEGER_MAX = " << INTEGER_MAX << '\n';
  cout << '\n';
  cout << fmt('f',27,2,JD) << " == " << YYYY << ' ' << MM << ' ' << DD 
        << " 00:00:00" << '\n';

  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD,YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';
  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD0,YYYY,MM,DD);
  cout << fmt('f',27,2,JD0) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';

  const INTEGER YYYY1 = 1582;
  const INTEGER MM1 = 10;
  const INTEGER DD1 = 15;
  const REAL JD1 = 2299160.5;

  YYYY = YYYY1;
  MM = MM1;
  DD = DD1;
  JD = JD1;

  cout << '\n';
  cout << fmt('f',27,2,JD) << " == " << YYYY << ' ' << MM << ' ' << DD 
        << " 00:00:00" << '\n';

  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD,YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';
  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD1,YYYY,MM,DD);
  cout << fmt('f',27,2,JD1) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';

  const INTEGER YYYY2 = 1582;
  const INTEGER MM2 = 10;
  const INTEGER DD2 = 15;
  const REAL JD2 = 2299160;

  YYYY = YYYY2;
  MM = MM2;
  DD = DD2;
  JD = JD2;

  cout << '\n';
  cout << fmt('f',27,2,JD) << ' '<< YYYY << ' ' << MM << ' ' << DD 
       << "  In disagreement area, I do" << '\n';

  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << ' ';
  julian(JD,YYYY,MM,DD);
  cout << YYYY << ' ' << MM << ' ' << DD 
       << "  not know what is correct." << '\n';
  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << ' '<< YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD2,YYYY,MM,DD);
  cout << fmt('f',27,2,JD2) << ' '<< YYYY << ' ' << MM << ' ' << DD << '\n';

  const INTEGER YYYY3 = 1850;
  const INTEGER MM3 = 1;
  const INTEGER DD3 = 1;
  const REAL JD3 = 2396758;

  YYYY = YYYY3;
  MM = MM3;
  DD = DD3;
  JD = JD3;

  cout << '\n';
  cout << fmt('f',27,2,JD) << " == " << 1849 << ' ' << 12 << ' ' << 31 
        << " 12:00:00" << '\n';

  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD,YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';
  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD3,YYYY,MM,DD);
  cout << fmt('f',27,2,JD3) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';
  
  const INTEGER YYYY4 = 1850;
  const INTEGER MM4 = 1;
  const INTEGER DD4 = 16;
  const REAL JD4 = 2396774;

  YYYY = YYYY4;
  MM = MM4;
  DD = DD4;
  JD = JD4;

  cout << '\n';
  cout << fmt('f',27,2,JD) << " == " << YYYY << ' ' << MM << ' ' << DD 
       << " 12:00:00" << '\n';

  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD,YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';
  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD4,YYYY,MM,DD);
  cout << fmt('f',27,2,JD4) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';
  
  const INTEGER YYYY5 = 2011;
  const INTEGER MM5 = 1;
  const INTEGER DD5 = 17;
  const INTEGER h5 = 14;
  const INTEGER m5 = 24;
  const INTEGER s5 = 0;
  const REAL JD5 = 2455579.1;

  YYYY = YYYY5;
  MM = MM5;
  DD = DD5;
  JD = JD5;
  INTEGER h = h5;
  INTEGER m = m5;
  INTEGER s = s5;

  cout << '\n';
  cout << fmt('f',27,2,JD) << " == " << YYYY << ' ' << MM << ' ' << DD 
       << " 14:24:00" << '\n';

  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD,YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';
  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD5,YYYY,MM,DD);
  cout << fmt('f',27,2,JD5) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';

  YYYY = YYYY5;
  MM = MM5;
  DD = DD5;
  JD = JD5;
  h = h5;
  m = m5;
  s = s5;

  cout << '\n';
  cout << fmt('f',37,10,JD) << " == " << YYYY << ' ' << MM << ' ' << DD 
       << " 14:24:00" << '\n';

  JD = julian(YYYY,MM,DD,h,m,s);
  cout << fmt('f',37,10,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD 
       << ' ' << fmt('d',2,h)('0') << ':' << fmt('d',2,m)('0') 
       << ':' << fmt('d',2,s)('0') << '\n';
  julian(JD,YYYY,MM,DD,h,m,s);
  cout << fmt('f',37,10,JD) << " -> " << YYYY << ' ' << MM << ' ' << DD
       << ' ' << fmt('d',2,h)('0') << ':' << fmt('d',2,m)('0') 
       << ':' << fmt('d',2,s)('0') << '\n';
  JD = julian(YYYY,MM,DD,h,m,s);
  cout << fmt('f',37,10,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD 
       << ' ' << fmt('d',2,h)('0') << ':' << fmt('d',2,m)('0') 
       << ':' << fmt('d',2,s)('0') << '\n';
  julian(JD5,YYYY,MM,DD,h,m,s);
  cout << fmt('f',37,10,JD5) << " -> " << YYYY << ' ' << MM << ' ' << DD 
       << ' ' << fmt('d',2,h)('0') << ':' << fmt('d',2,m)('0') 
       << ':' << fmt('d',2,s)('0') << '\n';

  const INTEGER YYYY6 = 2011;
  const INTEGER MM6 = 1;
  const INTEGER DD6 = 16;
  const REAL JD6 = 2455578.4;
  const INTEGER h6 = 21;
  const INTEGER m6 = 35;
  const INTEGER s6 = 60;

  YYYY = YYYY6;
  MM = MM6;
  DD = DD6;
  JD = JD6;
  h = h6;
  m = m6;
  s = s6;

  cout << '\n';
  cout << fmt('f',27,2,JD) << " == " << YYYY << ' ' << MM << ' ' << DD 
       << " 21:35:60" << '\n';

  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD,YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';
  JD = julian(YYYY,MM,DD);
  cout << fmt('f',27,2,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD6,YYYY,MM,DD);
  cout << fmt('f',27,2,JD6) << " -> " << YYYY << ' ' << MM << ' ' << DD << '\n';
  YYYY = YYYY6;

  MM = MM6;
  DD = DD6;
  JD = JD6;
  h = h6;
  m = m6;
  s = s6;

  cout << '\n';
  cout << fmt('f',37,10,JD) << " == " << YYYY << ' ' << MM << ' ' << DD 
       << " 21:35:60" << '\n';

  JD = julian(YYYY,MM,DD,h,m,s);
  cout << fmt('f',37,10,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD 
       << ' ' << fmt('d',2,h)('0') << ':' << fmt('d',2,m)('0') 
       << ':' << fmt('d',2,s)('0') << '\n';
  julian(JD,YYYY,MM,DD,h,m,s);
  cout << fmt('f',37,10,JD) << " -> " << YYYY << ' ' << MM << ' ' << DD
       << ' ' << fmt('d',2,h)('0') << ':' << fmt('d',2,m)('0') 
       << ':' << fmt('d',2,s)('0') << '\n';
  JD = julian(YYYY,MM,DD,h,m,s);
  cout << fmt('f',37,10,JD) << " <- " << YYYY << ' ' << MM << ' ' << DD
       << ' ' << fmt('d',2,h)('0') << ':' << fmt('d',2,m)('0') 
       << ':' << fmt('d',2,s)('0') << '\n';
  julian(JD6,YYYY,MM,DD,h,m,s);
  cout << fmt('f',37,10,JD6) << " -> " << YYYY << ' ' << MM << ' ' << DD
       << ' ' << fmt('d',2,h)('0') << ':' << fmt('d',2,m)('0') 
       << ':' << fmt('d',2,s)('0') << '\n';

  cout << '\n';
  for (INTEGER i=2299146; i<=2299176; ++i) {
    JD = REAL(i) + 0.5;
    julian(JD,YYYY,MM,DD);
    cout << fmt('f',27,2,JD) <<" -> "<< YYYY << ' ' << MM << ' ' << DD << '\n';
  }

  cout << '\n';
  for (INTEGER i=-5; i<=5; ++i) {
    REAL JD = julian(i, 1, 1, 12, 0, 0);
    cout << fmt('f',27,2,JD) <<" <- "<< fmt('d',2,i) << " 1 1 12:00:00" << '\n';
  }
    
  cout << '\n';
  YYYY = -1; MM = 12; DD = 31; 
  JD = julian(YYYY, MM, DD, 12, 0, 0);
  cout<< fmt('f',27,2,JD)<<" <- "<< YYYY <<' '<< MM <<' '<< DD <<" 12:00:00\n";
  YYYY = 0; MM = 1; DD = 1; 
  JD = julian(YYYY, MM, DD, 12, 0, 0);
  cout<< fmt('f',27,2,JD)<<" <-  "<< YYYY<<"  "<<MM<<"  "<<DD<<" 12:00:00\n";

  cout << '\n';
  JD = 0;
  julian(JD, YYYY, MM, DD);
  cout << fmt('f',27,2,JD) <<" -> "<< YYYY << ' ' << MM << ' ' << DD << '\n';
  YYYY = -4712; MM = 1; DD = 1; 
  JD = julian(YYYY, MM, DD, 12, 0, 0);
  cout << fmt('f',27,2,JD) <<" <- "<< YYYY << ' ' << MM << ' ' << DD << '\n';
  julian(JD, YYYY, MM, DD);
  cout << fmt('f',27,2,JD) <<" -> "<< YYYY << ' ' << MM << ' ' << DD << '\n';
  JD = -32044;
  julian(JD, YYYY, MM, DD);
  cout << fmt('f',27,2,JD) <<" -> "<< YYYY << ' ' << MM << ' ' << DD << '\n';

  cout << '\n';
  JD = 2455590;
  YYYY = 2011; MM = 1; DD = 28; 
  JD = julian(YYYY, MM, DD,12,0,0);
  cout<< fmt('f',27,5,JD)<<" <- "<< YYYY <<' '<< MM <<' '<< DD <<" 12:00:00\n";
  cout << "JD%7 = " << lround(JD)%7 << '\n';

  return 0;
}
